Index: /palm/trunk/SOURCE/surface_layer_fluxes_mod.f90
===================================================================
--- /palm/trunk/SOURCE/surface_layer_fluxes_mod.f90	(revision 2231)
+++ /palm/trunk/SOURCE/surface_layer_fluxes_mod.f90	(revision 2232)
@@ -20,5 +20,6 @@
 ! Current revisions:
 ! ------------------
-! 
+! Adjustments to new surface concept
+! OpenMP bugfix
 ! 
 ! Former revisions:
@@ -171,7 +172,6 @@
 
     USE arrays_3d,                                                             &
-        ONLY:  e, kh, nr, nrs, nrsws, ol, pt, q, ql, qr, qrs, qrsws, qs, qsws, &
-               s, shf, ss, ssws, ts, u, us, usws, v, vpt, vsws, zu, zw, z0,    &
-               z0h, z0q, drho_air_zw, rho_air_zw
+        ONLY:  e, kh, nr, pt, q, ql, qr, s, u, v, vpt, w, zu, zw, drho_air_zw, &
+               rho_air_zw
 
     USE cloud_parameters,                                                      &
@@ -187,15 +187,16 @@
                constant_waterflux, coupling_mode, g, humidity, ibc_e_b,        &
                ibc_pt_b, initializing_actions, kappa,                          &
-               intermediate_timestep_count,                                    &
-               intermediate_timestep_count_max, large_scale_forcing, lsf_surf, &
+               intermediate_timestep_count, intermediate_timestep_count_max,   &
+               land_surface, large_scale_forcing, lsf_surf,                    &
                message_string, microphysics_seifert, most_method, neutral,     &
                passive_scalar, pt_surface, q_surface, run_coupled,             &
                surface_pressure, simulated_time, terminate_run,                &
-               urban_surface,                                                  &
-               zeta_max, zeta_min 
+               urban_surface, zeta_max, zeta_min
+
+    USE grid_variables,                                                        &
+        ONLY:  dx, dy  
 
     USE indices,                                                               &
-        ONLY:  nxl, nxlg, nxr, nxrg, nys, nysg, nyn, nyng, nzb_s_inner,        &
-               nzb_u_inner, nzb_v_inner
+        ONLY:  nxl, nxr, nys, nyn, nzb
 
     USE kinds
@@ -204,6 +205,9 @@
 
     USE land_surface_model_mod,                                                &
-        ONLY:  land_surface, skip_time_do_lsm
-
+        ONLY:  aero_resist_kray, skip_time_do_lsm
+
+    USE surface_mod,                                                           &
+        ONLY :  surf_def_h, surf_def_v, surf_lsm_h, surf_lsm_v, surf_type,     &
+                surf_usm_h, surf_usm_v
         
 
@@ -213,13 +217,15 @@
     INTEGER(iwp) ::  j              !< loop index y direction
     INTEGER(iwp) ::  k              !< loop index z direction
-    INTEGER(iwp) ::  l_bnd  = 7500  !< Lookup table index of the last time step
-
-    INTEGER(iwp), PARAMETER     :: num_steps = 15000  !< number of steps in the lookup table
-
-    LOGICAL      ::  coupled_run  !< Flag for coupled atmosphere-ocean runs
-
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE :: pt1,      & !< Potential temperature at first grid level (required for cloud_physics = .T.)
-                                             qv1,      & !< Specific humidity at first grid level (required for cloud_physics = .T.)
-                                             uv_total    !< Total velocity at first grid level
+    INTEGER(iwp) ::  l              !< loop index for surf type
+    INTEGER(iwp) ::  li_bnd  = 7500 !< Lookup table index of the last time step
+
+    INTEGER(iwp), PARAMETER ::  num_steps = 15000  !< number of steps in the lookup table
+
+    LOGICAL      ::  coupled_run       !< Flag for coupled atmosphere-ocean runs
+    LOGICAL      ::  downward = .FALSE.!< Flag indicating downward-facing horizontal surface
+    LOGICAL      ::  mom_uv  = .FALSE. !< Flag indicating calculation of usvs and vsus at vertical surfaces
+    LOGICAL      ::  mom_w   = .FALSE. !< Flag indicating calculation of wsus and wsvs at vertical surfaces
+    LOGICAL      ::  mom_tke = .FALSE. !< Flag indicating calculation of momentum fluxes at vertical surfaces used for TKE production 
+    LOGICAL      ::  surf_vertical     !< Flag indicating vertical surfaces
 
     REAL(wp), DIMENSION(0:num_steps-1) :: rib_tab,  & !< Lookup table bulk Richardson number
@@ -232,4 +238,6 @@
                      z_mo                 !< Height of the constant flux layer where MOST is assumed
 
+    TYPE(surf_type), POINTER ::  surf     !< surf-type array, used to generalize subroutines
+
 
     SAVE
@@ -237,5 +245,5 @@
     PRIVATE
 
-    PUBLIC init_surface_layer_fluxes, pt1, qv1, surface_layer_fluxes, uv_total
+    PUBLIC init_surface_layer_fluxes, surface_layer_fluxes
 
     INTERFACE init_surface_layer_fluxes
@@ -260,4 +268,6 @@
        IMPLICIT NONE
 
+       surf_vertical = .FALSE.
+       downward      = .FALSE.
 !
 !--    In case cloud physics is used, it is required to derive potential
@@ -265,5 +275,25 @@
 !--    and q
        IF ( cloud_physics )  THEN
-          CALL calc_pt_q
+!
+!--       First call for horizontal default-type surfaces (l=0 - upward facing, 
+!--       l=1 - downward facing)
+          DO  l = 0, 1
+             IF ( surf_def_h(l)%ns >= 1  )  THEN
+                surf => surf_def_h(l)
+                CALL calc_pt_q
+             ENDIF
+          ENDDO
+!
+!--       Call for natural-type surfaces
+          IF ( surf_lsm_h%ns >= 1  )  THEN
+             surf => surf_lsm_h
+             CALL calc_pt_q
+          ENDIF
+!
+!--       Call for urban-type surfaces
+          IF ( surf_usm_h%ns >= 1  )  THEN
+             surf => surf_usm_h
+             CALL calc_pt_q
+          ENDIF
        ENDIF
 
@@ -277,36 +307,373 @@
 !
 !--    Depending on setting of most_method use the "old" routine
+!--    Note, each routine is called for different surface types. 
+!--    First call for default-type horizontal surfaces, for natural- and 
+!--    urban-type surfaces. Note, at this place only upward-facing horizontal
+!--    surfaces are treted. 
        IF ( most_method == 'circular' )  THEN
-
-          CALL calc_scaling_parameters
-
-          CALL calc_uv_total
-
-          IF ( .NOT. neutral )  THEN
-             CALL calc_ol
-          ENDIF
-
-          CALL calc_us
-
-          CALL calc_surface_fluxes
-
+!
+!--       Default-type upward-facing horizontal surfaces
+          IF ( surf_def_h(0)%ns >= 1  )  THEN
+             surf => surf_def_h(0)
+             CALL calc_scaling_parameters
+             CALL calc_uvw_abs
+             IF ( .NOT. neutral )  CALL calc_ol
+             CALL calc_us
+             CALL calc_surface_fluxes
+          ENDIF
+!
+!--       Natural-type horizontal surfaces
+          IF ( surf_lsm_h%ns >= 1  )  THEN
+             surf => surf_lsm_h
+             CALL calc_scaling_parameters
+             CALL calc_uvw_abs
+             IF ( .NOT. neutral )  CALL calc_ol
+             CALL calc_us
+             CALL calc_surface_fluxes
+          ENDIF
+!
+!--       Urban-type horizontal surfaces
+          IF ( surf_usm_h%ns >= 1  )  THEN
+             surf => surf_usm_h
+             CALL calc_scaling_parameters
+             CALL calc_uvw_abs
+             IF ( .NOT. neutral )  CALL calc_ol
+             CALL calc_us
+             CALL calc_surface_fluxes
+          ENDIF
 !
 !--    Use either Newton iteration or a lookup table for the bulk Richardson
 !--    number to calculate the Obukhov length 
        ELSEIF ( most_method == 'newton'  .OR.  most_method == 'lookup' )  THEN
-
-          CALL calc_uv_total
-
-          IF ( .NOT. neutral )  THEN
-             CALL calc_ol
-          ENDIF
-
+!
+!--       Default-type upward-facing horizontal surfaces
+          IF ( surf_def_h(0)%ns >= 1  )  THEN
+             surf => surf_def_h(0)
+             CALL calc_uvw_abs
+             IF ( .NOT. neutral )  CALL calc_ol
+             CALL calc_us
+             CALL calc_scaling_parameters
+             CALL calc_surface_fluxes
+          ENDIF
+!
+!--       Natural-type horizontal surfaces
+          IF ( surf_lsm_h%ns >= 1  )  THEN
+             surf => surf_lsm_h
+             CALL calc_uvw_abs
+             IF ( .NOT. neutral )  CALL calc_ol
+             CALL calc_us
+             CALL calc_scaling_parameters
+             CALL calc_surface_fluxes
+          ENDIF
+!
+!--       Urban-type horizontal surfaces
+          IF ( surf_usm_h%ns >= 1  )  THEN
+             surf => surf_usm_h
+             CALL calc_uvw_abs
+             IF ( .NOT. neutral )  CALL calc_ol
+             CALL calc_us
+             CALL calc_scaling_parameters
+             CALL calc_surface_fluxes
+          ENDIF
+
+       ENDIF
+!
+!--    Treat downward-facing horizontal surfaces. Note, so far, these are 
+!--    always default type. Stratification is not considered
+!--    in this case, hence, no further distinction between different 
+!--    most_method is required.  
+       IF ( surf_def_h(1)%ns >= 1  )  THEN
+          downward = .TRUE.
+          surf => surf_def_h(1)
+          CALL calc_uvw_abs
           CALL calc_us
-
-          CALL calc_scaling_parameters
-
           CALL calc_surface_fluxes
-
+          downward = .FALSE.
        ENDIF
+!
+!--    Calculate surfaces fluxes at vertical surfaces for momentum 
+!--    and subgrid-scale TKE.
+!--    No stability is considered. Therefore, scaling parameters and Obukhov-
+!--    length do not need to be calculated and no distinction in 'circular',
+!--    'Newton' or 'lookup' is necessary so far. 
+!--    Note, this will change if stability is once considered.
+       surf_vertical = .TRUE.
+!
+!--    Calculate horizontal momentum fluxes at north- and south-facing 
+!--    surfaces(usvs).
+!--    For default-type surfaces
+       mom_uv = .TRUE. 
+       DO  l = 0, 1
+          IF ( surf_def_v(l)%ns >= 1  )  THEN
+             surf => surf_def_v(l)
+!
+!--          Compute surface-parallel velocity
+             CALL calc_uvw_abs_v_ugrid
+!
+!--          Compute respective friction velocity on staggered grid
+             CALL calc_us
+!
+!--          Compute respective surface fluxes for momentum and TKE
+             CALL calc_surface_fluxes
+          ENDIF
+       ENDDO
+!
+!--    For natural-type surfaces. Please note, even though stability is not
+!--    considered for the calculation of momentum fluxes at vertical surfaces,
+!--    scaling parameters and Obukov length are calculated nevertheless in this
+!--    case. This is due to the requirement of ts in parameterization of heat
+!--    flux in land-surface model in case of aero_resist_kray is not true.
+       IF ( .NOT. aero_resist_kray )  THEN
+          IF ( most_method == 'circular' )  THEN
+             DO  l = 0, 1
+                IF ( surf_lsm_v(l)%ns >= 1  )  THEN
+                   surf => surf_lsm_v(l)
+!
+!--                Compute scaling parameters
+                   CALL calc_scaling_parameters
+!
+!--                Compute surface-parallel velocity
+                   CALL calc_uvw_abs_v_ugrid
+!
+!--                Compute Obukhov length
+                   IF ( .NOT. neutral )  CALL calc_ol
+!
+!--                Compute respective friction velocity on staggered grid
+                   CALL calc_us
+!
+!--                Compute respective surface fluxes for momentum and TKE
+                   CALL calc_surface_fluxes
+                ENDIF
+             ENDDO
+          ELSE
+             DO  l = 0, 1
+                IF ( surf_lsm_v(l)%ns >= 1  )  THEN
+                   surf => surf_lsm_v(l)
+!
+!--                Compute surface-parallel velocity
+                   CALL calc_uvw_abs_v_ugrid
+!
+!--                Compute Obukhov length
+                   IF ( .NOT. neutral )  CALL calc_ol
+!
+!--                Compute respective friction velocity on staggered grid
+                   CALL calc_us
+!
+!--                Compute scaling parameters
+                   CALL calc_scaling_parameters
+!
+!--                Compute respective surface fluxes for momentum and TKE
+                   CALL calc_surface_fluxes
+                ENDIF
+             ENDDO
+          ENDIF
+!
+!--    No ts is required, so scaling parameters and Obukhov length do not need
+!--    to be computed.
+       ELSE
+          DO  l = 0, 1
+             IF ( surf_lsm_v(l)%ns >= 1  )  THEN
+                surf => surf_lsm_v(l)
+!   
+!--             Compute surface-parallel velocity
+                CALL calc_uvw_abs_v_ugrid
+!
+!--             Compute respective friction velocity on staggered grid
+                CALL calc_us
+!
+!--             Compute respective surface fluxes for momentum and TKE
+                CALL calc_surface_fluxes
+             ENDIF
+          ENDDO
+       ENDIF
+!
+!--    For urban-type surfaces
+       DO  l = 0, 1
+          IF ( surf_usm_v(l)%ns >= 1  )  THEN
+             surf => surf_usm_v(l)
+!
+!--          Compute surface-parallel velocity
+             CALL calc_uvw_abs_v_ugrid
+!
+!--          Compute respective friction velocity on staggered grid
+             CALL calc_us
+!
+!--          Compute respective surface fluxes for momentum and TKE
+             CALL calc_surface_fluxes
+          ENDIF
+       ENDDO
+!
+!--    Calculate horizontal momentum fluxes at east- and west-facing 
+!--    surfaces (vsus).
+!--    For default-type surfaces
+       DO  l = 2, 3
+          IF ( surf_def_v(l)%ns >= 1  )  THEN
+             surf => surf_def_v(l)
+!
+!--          Compute surface-parallel velocity
+             CALL calc_uvw_abs_v_vgrid
+!
+!--          Compute respective friction velocity on staggered grid
+             CALL calc_us
+!
+!--          Compute respective surface fluxes for momentum and TKE
+             CALL calc_surface_fluxes
+          ENDIF
+       ENDDO
+!
+!--    For natural-type surfaces. Please note, even though stability is not
+!--    considered for the calculation of momentum fluxes at vertical surfaces,
+!--    scaling parameters and Obukov length are calculated nevertheless in this
+!--    case. This is due to the requirement of ts in parameterization of heat
+!--    flux in land-surface model in case of aero_resist_kray is not true.
+       IF ( .NOT. aero_resist_kray )  THEN
+          IF ( most_method == 'circular' )  THEN
+             DO  l = 2, 3
+                IF ( surf_lsm_v(l)%ns >= 1  )  THEN
+                   surf => surf_lsm_v(l)
+!
+!--                Compute scaling parameters
+                   CALL calc_scaling_parameters
+!
+!--                Compute surface-parallel velocity
+                   CALL calc_uvw_abs_v_vgrid
+!
+!--                Compute Obukhov length
+                   IF ( .NOT. neutral )  CALL calc_ol
+!
+!--                Compute respective friction velocity on staggered grid
+                   CALL calc_us
+!
+!--                Compute respective surface fluxes for momentum and TKE
+                   CALL calc_surface_fluxes
+                ENDIF
+             ENDDO
+          ELSE
+             DO  l = 2, 3
+                IF ( surf_lsm_v(l)%ns >= 1  )  THEN
+                   surf => surf_lsm_v(l)
+!
+!--                Compute surface-parallel velocity
+                   CALL calc_uvw_abs_v_vgrid
+!
+!--                Compute Obukhov length
+                   IF ( .NOT. neutral )  CALL calc_ol
+!
+!--                Compute respective friction velocity on staggered grid
+                   CALL calc_us
+!
+!--                Compute scaling parameters
+                   CALL calc_scaling_parameters
+!
+!--                Compute respective surface fluxes for momentum and TKE
+                   CALL calc_surface_fluxes
+                ENDIF
+             ENDDO
+          ENDIF
+       ELSE
+          DO  l = 2, 3
+             IF ( surf_lsm_v(l)%ns >= 1  )  THEN
+                surf => surf_lsm_v(l)
+!   
+!--             Compute surface-parallel velocity
+                CALL calc_uvw_abs_v_vgrid
+!
+!--             Compute respective friction velocity on staggered grid
+                CALL calc_us
+!
+!--             Compute respective surface fluxes for momentum and TKE
+                CALL calc_surface_fluxes
+             ENDIF
+          ENDDO
+       ENDIF
+!
+!--    For urban-type surfaces
+       DO  l = 2, 3
+          IF ( surf_usm_v(l)%ns >= 1  )  THEN
+             surf => surf_usm_v(l)
+!
+!--          Compute surface-parallel velocity
+             CALL calc_uvw_abs_v_vgrid
+!
+!--          Compute respective friction velocity on staggered grid
+             CALL calc_us
+!
+!--          Compute respective surface fluxes for momentum and TKE
+             CALL calc_surface_fluxes
+          ENDIF
+       ENDDO
+       mom_uv = .FALSE.
+!
+!--    Calculate horizontal momentum fluxes of w (wsus and wsvs) at vertial 
+!--    surfaces.
+       mom_w = .TRUE.
+!
+!--    Default-type surfaces
+       DO  l = 0, 3
+          IF ( surf_def_v(l)%ns >= 1  )  THEN
+             surf => surf_def_v(l)
+             CALL calc_uvw_abs_v_wgrid
+             CALL calc_us
+             CALL calc_surface_fluxes
+          ENDIF
+       ENDDO 
+!
+!--    Natural-type surfaces
+       DO  l = 0, 3
+          IF ( surf_lsm_v(l)%ns >= 1  )  THEN
+             surf => surf_lsm_v(l)
+             CALL calc_uvw_abs_v_wgrid
+             CALL calc_us
+             CALL calc_surface_fluxes
+          ENDIF
+       ENDDO 
+!
+!--    Urban-type surfaces
+       DO  l = 0, 3
+          IF ( surf_usm_v(l)%ns >= 1  )  THEN
+             surf => surf_usm_v(l)
+             CALL calc_uvw_abs_v_wgrid
+             CALL calc_us
+             CALL calc_surface_fluxes
+          ENDIF
+       ENDDO 
+       mom_w = .FALSE.   
+!
+!--    Calculate momentum fluxes usvs, vsus, wsus and wsvs at vertical 
+!--    surfaces for TKE production. Note, here, momentum fluxes are defined 
+!--    at grid center and are not staggered as before.
+       mom_tke = .TRUE.
+!
+!--    Default-type surfaces
+       DO  l = 0, 3
+          IF ( surf_def_v(l)%ns >= 1  )  THEN
+             surf => surf_def_v(l)
+             CALL calc_uvw_abs_v_sgrid
+             CALL calc_us
+             CALL calc_surface_fluxes
+          ENDIF
+       ENDDO 
+!
+!--    Natural-type surfaces
+       DO  l = 0, 3
+          IF ( surf_lsm_v(l)%ns >= 1  )  THEN
+             surf => surf_lsm_v(l)
+             CALL calc_uvw_abs_v_sgrid
+             CALL calc_us
+             CALL calc_surface_fluxes
+          ENDIF
+       ENDDO 
+!
+!--    Urban-type surfaces
+       DO  l = 0, 3
+          IF ( surf_usm_v(l)%ns >= 1  )  THEN
+             surf => surf_usm_v(l)
+             CALL calc_uvw_abs_v_sgrid
+             CALL calc_us
+             CALL calc_surface_fluxes
+          ENDIF
+       ENDDO 
+       mom_tke = .FALSE.
+  
 
     END SUBROUTINE surface_layer_fluxes
@@ -324,5 +691,5 @@
        IMPLICIT NONE
 
-       INTEGER(iwp) :: l,          & !< Index for loop to create lookup table
+       INTEGER(iwp) :: li,         & !< Index for loop to create lookup table
                        num_steps_n   !< Number of non-stretched zeta steps
 
@@ -339,15 +706,6 @@
                    z0h_min   = 0.0_wp,   & !< Minimum value of z0h to create table
                    z0_min    = 0.0_wp      !< Minimum value of z0 to create table
-!
-!--    When cloud physics is used, arrays for storing potential temperature and
-!--    specific humidity at first grid level are required
-       IF ( cloud_physics )  THEN
-          ALLOCATE ( pt1(nysg:nyng,nxlg:nxrg) )
-          ALLOCATE ( qv1(nysg:nyng,nxlg:nxrg) )
-       ENDIF
-
-!
-!--    Allocate field for storing the horizontal velocity
-       ALLOCATE ( uv_total(nysg:nyng,nxlg:nxrg) )
+
+
 
 
@@ -355,5 +713,9 @@
 !--    In case of runs with neutral statification, set Obukhov length to a
 !--    large value
-       IF ( neutral ) ol = 1.0E10_wp
+       IF ( neutral )  THEN
+          IF ( surf_def_h(0)%ns >= 1 )  surf_def_h(0)%ol = 1.0E10_wp
+          IF ( surf_lsm_h%ns    >= 1 )  surf_lsm_h%ol    = 1.0E10_wp
+          IF ( surf_usm_h%ns    >= 1 )  surf_usm_h%ol    = 1.0E10_wp
+       ENDIF
 
        IF ( most_method == 'lookup' )  THEN
@@ -361,9 +723,44 @@
 !
 !--       Check for roughness heterogeneity. In that case terminate run and
-!--       inform user
-          IF ( MINVAL( z0h ) /= MAXVAL( z0h )  .OR.                            &
-               MINVAL( z0  ) /= MAXVAL( z0  ) )  THEN
-             terminate_run_l = .TRUE.
-          ENDIF
+!--       inform user. Check for both, natural and non-natural walls.
+          IF ( surf_def_h(0)%ns >= 1 )  THEN
+             IF ( MINVAL( surf_def_h(0)%z0h ) /= MAXVAL( surf_def_h(0)%z0h )  .OR. &
+                  MINVAL( surf_def_h(0)%z0  ) /= MAXVAL( surf_def_h(0)%z0  ) )  THEN
+                terminate_run_l = .TRUE.
+             ENDIF
+          ENDIF
+          IF ( surf_lsm_h%ns >= 1 )  THEN
+             IF ( MINVAL( surf_lsm_h%z0h ) /= MAXVAL( surf_lsm_h%z0h )  .OR.       &
+                  MINVAL( surf_lsm_h%z0  ) /= MAXVAL( surf_lsm_h%z0  ) )  THEN
+                terminate_run_l = .TRUE.
+             ENDIF
+          ENDIF
+          IF ( surf_usm_h%ns >= 1 )  THEN
+             IF ( MINVAL( surf_usm_h%z0h ) /= MAXVAL( surf_usm_h%z0h )  .OR.       &
+                  MINVAL( surf_usm_h%z0  ) /= MAXVAL( surf_usm_h%z0  ) )  THEN
+                terminate_run_l = .TRUE.
+             ENDIF
+          ENDIF
+!
+!--       Check roughness homogeneity between differt surface types. 
+          IF ( surf_lsm_h%ns >= 1  .AND.  surf_def_h(0)%ns >= 1 )  THEN
+             IF ( MINVAL( surf_lsm_h%z0h ) /= MAXVAL( surf_def_h(0)%z0h )  .OR.    &
+                  MINVAL( surf_lsm_h%z0  ) /= MAXVAL( surf_def_h(0)%z0  ) )  THEN
+                terminate_run_l = .TRUE.
+             ENDIF
+          ENDIF
+          IF ( surf_usm_h%ns >= 1  .AND.  surf_def_h(0)%ns >= 1 )  THEN
+             IF ( MINVAL( surf_usm_h%z0h ) /= MAXVAL( surf_def_h(0)%z0h )  .OR.    &
+                  MINVAL( surf_usm_h%z0  ) /= MAXVAL( surf_def_h(0)%z0  ) )  THEN
+                terminate_run_l = .TRUE.
+             ENDIF
+          ENDIF
+          IF ( surf_usm_h%ns >= 1  .AND.  surf_lsm_h%ns >= 1 )  THEN
+             IF ( MINVAL( surf_usm_h%z0h ) /= MAXVAL( surf_lsm_h%z0h )  .OR.       &
+                  MINVAL( surf_usm_h%z0  ) /= MAXVAL( surf_lsm_h%z0  ) )  THEN
+                terminate_run_l = .TRUE.
+             ENDIF
+          ENDIF
+
 
 #if defined( __parallel )
@@ -389,5 +786,5 @@
 !
 !--       Use the lowest possible value for z_mo
-          k    = MINVAL(nzb_s_inner)
+          k    = nzb
           z_mo = zu(k+1) - zw(k)
 
@@ -401,6 +798,6 @@
           zeta_step   = (zeta_max - zeta_stretch) / REAL(num_steps_n)
 
-          DO l = 1, num_steps_n
-             zeta_tmp(l) = zeta_tmp(l-1) + zeta_step
+          DO li = 1, num_steps_n
+             zeta_tmp(li) = zeta_tmp(li-1) + zeta_step
           ENDDO
 
@@ -415,6 +812,6 @@
 !
 !--       Calculate z/L range from zeta_min to zeta_stretch
-          DO l = num_steps_n+1, num_steps-1
-             zeta_tmp(l) = zeta_tmp(l-1) + zeta_step
+          DO li = num_steps_n+1, num_steps-1
+             zeta_tmp(li) = zeta_tmp(li-1) + zeta_step
              zeta_step = zeta_step * regr
           ENDDO
@@ -422,7 +819,14 @@
 !
 !--       Save roughness lengths to temporary variables
-          z0h_min = z0h(nys,nxl)
-          z0_min  = z0(nys,nxl)
-          
+          IF ( surf_def_h(0)%ns >= 1  )  THEN
+             z0h_min = surf_def_h(0)%z0h(1)
+             z0_min  = surf_def_h(0)%z0(1)
+          ELSEIF ( surf_lsm_h%ns >= 1 )  THEN
+             z0h_min = surf_lsm_h%z0h(1)
+             z0_min  = surf_lsm_h%z0(1)
+          ELSEIF ( surf_usm_h%ns >= 1 )  THEN
+             z0h_min = surf_usm_h%z0h(1)
+             z0_min  = surf_usm_h%z0(1)
+          ENDIF         
 !
 !--       Calculate lookup table for the Richardson number versus Obukhov length
@@ -430,21 +834,21 @@
 !--       boundary conditions for temperature
           IF ( ibc_pt_b == 1 )  THEN
-             DO l = 0, num_steps-1
-                ol_tab(l)  = - z_mo / zeta_tmp(num_steps-1-l)
-                rib_tab(l) = z_mo / ol_tab(l)  / ( LOG( z_mo / z0_min )        &
-                                                - psi_m( z_mo / ol_tab(l) )    &
-                                                + psi_m( z0_min / ol_tab(l) )  &
+             DO li = 0, num_steps-1
+                ol_tab(li)  = - z_mo / zeta_tmp(num_steps-1-li)
+                rib_tab(li) = z_mo / ol_tab(li)  / ( LOG( z_mo / z0_min )       &
+                                                - psi_m( z_mo / ol_tab(li) )    &
+                                                + psi_m( z0_min / ol_tab(li) )  &
                                                   )**3
              ENDDO  
           ELSE
-             DO l = 0, num_steps-1
-                ol_tab(l)  = - z_mo / zeta_tmp(num_steps-1-l)
-                rib_tab(l) = z_mo / ol_tab(l)  * ( LOG( z_mo / z0h_min )       &
-                                              - psi_h( z_mo / ol_tab(l) )      &
-                                              + psi_h( z0h_min / ol_tab(l) )   &
+             DO li = 0, num_steps-1
+                ol_tab(li)  = - z_mo / zeta_tmp(num_steps-1-li)
+                rib_tab(li) = z_mo / ol_tab(li)  * ( LOG( z_mo / z0h_min )     &
+                                              - psi_h( z_mo / ol_tab(li) )     &
+                                              + psi_h( z0h_min / ol_tab(li) )  &
                                             )                                  &
                                           / ( LOG( z_mo / z0_min )             &
-                                              - psi_m( z_mo / ol_tab(l) )      &
-                                              + psi_m( z0_min / ol_tab(l) )    &
+                                              - psi_m( z_mo / ol_tab(li) )     &
+                                              + psi_m( z0_min / ol_tab(li) )   &
                                             )**2
              ENDDO
